#include "common.h"
#include <string.h>
#include <stdio.h>

char errmsg[256];
int CardInfo::counter;
int CardInfo::reverse=0;

//--------------------------

const char* Time::tostr() const {
  static char buf[20];
  assert(tv.tv_sec);

  time_t s=tv.tv_sec;
  tm* t=localtime(&s);

  sprintf(buf,"%.4i-%.2i-%-.2i %.2i:%.2i:%.2i", 
          t->tm_year+1900,t->tm_mon+1,t->tm_mday,t->tm_hour,t->tm_min,t->tm_sec);
	  
  return buf;	 
}     

//--------------------------

const char* mac_addr::tostr() const {
  static char buf[42];
  buf[0]='\x0';
  
  for(int a=0; a<6; a++) {
    sprintf(buf+strlen(buf),"%.2x",ea.ether_addr_octet[a]);
    if(a!=5) strcat(buf,":");
  }
  
  return buf;	   
}

int mac_addr::getmaxlen_tostr() {
  return 17;
}  

void mac_addr::setNull() {
  memset(&ea,0,sizeof(ea));
};  

int mac_addr::fromstr(const char* c) {
  return ether_aton_r(c,&ea) ? 0 : -1;
}

int mac_addr::isBrdCast() {
  for(int a=0; a<sizeof(ea.ether_addr_octet); a++) {
    if(ea.ether_addr_octet[a]!=0xff) return 0;
  }
  return 1;
}  

//--------------------------

const char* ip_addr::tostr(int comp) const {
  static char buf[42];
  unsigned long l=ntohl(ia.s_addr);
  
  buf[0]='\x0';
  for(int a=comp-1; a>=0; a--) {
    sprintf(buf+strlen(buf),"%i",(l>>(a*8)) & 0xFF);
    if(a!=0) strcat(buf,".");
  }
  
  return buf;
}

int ip_addr::getmaxlen_tostr(int comp) {
  return comp*4-1;
}

int ip_addr::fromstr(const char* c) {
  return inet_aton(c,&ia) ? 0 : -1;
}

void ip_addr::setNull() {
  memset(&ia,0,sizeof(ia));
};
