// This module implements the parser for the programs given in the [program]
// section of the configurtion file. Currently only one instance of this class
// may exist.

class ParseProgram {
  friend class addMac;
  friend class Symtable;
  
  static ParseProgram* instance; // Current instance of class or 0

  public:
  // The possible types for symbols:
  enum types { tINT,tMAC,tIP };
  
  ParseProgram();
  ~ParseProgram();
  
  // To set the program to execute call this funtion with the program
  // as a parameter. Returns an error message or 0 on succes. The
  // getSymbol is called for all encounterd symbols.
  char* setProgram(char*);  
  
  // Called by setProgram for each encounterd symbol. Should return
  // the type of symbol. If location is set to a nonzero value that
  // memory location is used for the symbol. Else a new memory location
  // is made for the symbol and it's contest is set to 0:
  virtual types getSymbol(char* name, void*& location)=0;
    
  // If setProgram returned successfully this can be called as many times
  // as wanted to execute the program.
  void execProgram();
  
  // The following is called by execProgram when a MAC-increment statement
  // is executed. The first parameter indicates the mac address. 
  // counterc is set to the number of elements in counters. Each element in 
  // counters is a pointer to the number of the counter to increment.
  virtual void macIncr(mac_addr,int counterc, int** counters, int size)=0;
};
